[BASH] Script to manage background scripts (running, finished, exit code)


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting [BASH] Script to manage background scripts (running, finished, exit code)
# 15  
Old 10-16-2014
Quote:
Originally Posted by Chubler_XL
First time I've seen this approach does this actually signal the running process in any way?

Do you know how portable this zero signal is?
Quote:
Originally Posted by Corona688
kill is faster than ps? I think they're both externals..
The POSIX Standards and the Single UNIX Specifications specify that the function call:
Code:
kill(pid, 0)

shall not actually send a signal but shall perform normai error checking. So, if the process ID is valid and you have permission to send that process a signal, it will return 0; otherwise, it will return -1 with errno set to ESRCH if the process doesn't exist or EPERM if you don't have permission to send a signal to your child. The standards also require that the kill utility behave as though kill(pid, 0) were called when you invoke the command kill -0 pid. All UNIX Systems do this; I can't speak to whether or not Linux systems' kill utilities and system calls conform to these requirements.

As Chubler_XL said, any shell that handles job control that I've seen has kill as a shell built-in. Even if it doesn't, ps usually needs to do a lot more poking around in kernel memory than kill does; so it should be faster.
This User Gave Thanks to Don Cragun For This Post:
# 16  
Old 10-17-2014
Hi.

Obviously a lot of work and thought has been put into this. As far as I know, the requirements:
Code:
    * 'any' amount of scripts passed,
    * provides a limiter, so only X scripts are running simultaneously
    * Prints the status code of each of the scripts ran

can be accomplished through utilities xargs and GNU parallel. Here's an example of a number of script names in a data file that will be "executed". First singly (not in parallel), then at most n=2 at a time. The script that "runs" the script name is run with ksh so that the number of processes can be more easily seen.
Code:
#!/usr/bin/env bash

# @(#) s1	Demonstrate parallel execution of scripts, GNU parallel.

# Utility functions: print-as-echo, print-line-with-visual-space, debug.
# export PATH="/usr/local/bin:/usr/bin:/bin"
LC_ALL=C ; LANG=C ; export LC_ALL LANG
pe() { for _i;do printf "%s" "$_i";done; printf "\n"; }
pl() { pe;pe "-----" ;pe "$*"; }
db() { ( printf " db, ";for _i;do printf "%s" "$_i";done;printf "\n" ) >&2 ; }
db() { : ; }
C=$HOME/bin/context && [ -f $C ] && $C parallel

FILE=${1-data1}

pl " Input data file, names of scripts, $FILE:"
cat $FILE

pl " Master execution script s0:"
cat s0

pl " Results:"
parallel ./s0 < $FILE

pl " Results, limitation of 2 scripts simultaneously:"
parallel --jobs 2 ./s0 < $FILE

exit 0

producing:
Code:
$ ./s1

Environment: LC_ALL = C, LANG = C
(Versions displayed with local utility "version")
OS, ker|rel, machine: Linux, 2.6.26-2-amd64, x86_64
Distribution        : Debian 5.0.8 (lenny, workstation) 
bash GNU bash 3.2.39
parallel GNU parallel 20111122

-----
 Input data file, names of scripts, data1:
foo
bar
baz
qux
quux
corge

-----
 Master execution script s0:
#!/usr/bin/env ksh

# @(#) s0	Demonstrate script to execute a script from argument 1.

printf " $0: would have executed script %s here, process $$\n" $1
printf " exit status of script %s is %d\n" $1 $?
printf " Current processes:\n"
ps
sleep 1

exit 0

-----
 Results:
 ./s0: would have executed script foo here, process 12774
 exit status of script foo is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12734 pts/13   00:00:00 parallel
12774 pts/13   00:00:00 ksh
12775 pts/13   00:00:00 ps
 ./s0: would have executed script bar here, process 12776
 exit status of script bar is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12734 pts/13   00:00:00 parallel
12776 pts/13   00:00:00 ksh
12777 pts/13   00:00:00 ps
 ./s0: would have executed script baz here, process 12781
 exit status of script baz is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12734 pts/13   00:00:00 parallel
12781 pts/13   00:00:00 ksh
12782 pts/13   00:00:00 ps
 ./s0: would have executed script qux here, process 12783
 exit status of script qux is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12734 pts/13   00:00:00 parallel
12783 pts/13   00:00:00 ksh
12784 pts/13   00:00:00 ps
 ./s0: would have executed script quux here, process 12785
 exit status of script quux is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12734 pts/13   00:00:00 parallel
12785 pts/13   00:00:00 ksh
12786 pts/13   00:00:00 ps
 ./s0: would have executed script corge here, process 12787
 exit status of script corge is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12734 pts/13   00:00:00 parallel
12787 pts/13   00:00:00 ksh
12788 pts/13   00:00:00 ps

-----
 Results, limitation of 2 scripts simultaneously:
 ./s0: would have executed script foo here, process 12815
 exit status of script foo is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12789 pts/13   00:00:00 parallel
12815 pts/13   00:00:00 ksh
12816 pts/13   00:00:00 ps
12817 pts/13   00:00:00 ksh
12818 pts/13   00:00:00 ps
 ./s0: would have executed script bar here, process 12817
 exit status of script bar is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12789 pts/13   00:00:00 parallel
12815 pts/13   00:00:00 ksh
12817 pts/13   00:00:00 ksh
12818 pts/13   00:00:00 ps
 ./s0: would have executed script baz here, process 12822
 exit status of script baz is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12789 pts/13   00:00:00 parallel
12822 pts/13   00:00:00 ksh
12823 pts/13   00:00:00 ps
12824 pts/13   00:00:00 ksh
12825 pts/13   00:00:00 ps
 ./s0: would have executed script qux here, process 12824
 exit status of script qux is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12789 pts/13   00:00:00 parallel
12822 pts/13   00:00:00 ksh
12824 pts/13   00:00:00 ksh
12825 pts/13   00:00:00 ps
 ./s0: would have executed script corge here, process 12828
 exit status of script corge is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12789 pts/13   00:00:00 parallel
12826 pts/13   00:00:00 ksh
12827 pts/13   00:00:00 ps
12828 pts/13   00:00:00 ksh
12829 pts/13   00:00:00 ps
 ./s0: would have executed script quux here, process 12826
 exit status of script quux is 0
 Current processes:
  PID TTY          TIME CMD
 3451 pts/13   00:00:01 bash
12670 pts/13   00:00:00 bash
12789 pts/13   00:00:00 parallel
12826 pts/13   00:00:00 ksh
12827 pts/13   00:00:00 ps
12828 pts/13   00:00:00 ksh
12829 pts/13   00:00:00 ps

My apologies if I missed the point ... cheers, drl
This User Gave Thanks to drl For This Post:
# 17  
Old 10-17-2014
His original script would have been able to run entire, complex, arbitrary shell statements in parallel. He wasn't testing it with them, but it could. This isn't necessarily a good thing, mind you -- leaves the door open for a lot of unintended problems.
# 18  
Old 10-18-2014
Thank you guys, i've tried to adapt some of your suggestions, /proc/$pid, kill -0 $pid, kill($pid,0) but none of them worked as expected.
The hint with a "single id number" was great, that way i just managed to make it even smaller than the previous example, with full functionality! Smilie

Screenshot shows how it returns the number of successfully executed scripts, when passed -c...

Below is the 'core' snippet, full script can be seen on https://github.com/sri-arjuna/tui/bl...er/bin/tui-psm
And it is part of: https://github.com/sri-arjuna/tui.git

Hope you like it, and thank you for your help!
Code:
#
#	Variable presets
#
	script_name=( "${@}" )		# Contains all files
	MAX=${#script_name[@]}		# Max amount of scripts
	script_status=( $(for s in "${script_name[@]}";do echo "3";done) )		# Status with same counter of that file	: done(0) failed(1) running(2) todo(3)
	script_pid=()			# PID with the same counter of that file

	# Counters
	RUN=0			# How many scripts are currently running
#
#	Display & Action
#
	while [[ $DONE -lt $MAX ]]
	do	# Loop the menu
		C=0
		DONE=0			# How many scripts are 'done' (regardless of status)
		GOOD=0			# How many scripts ended succesffully
		if ! $QUIET
		then	clear
			tui-header "$TITLE ($script_version)" "$(date +'%F %T')"
			tui-title "Status"
		fi
		
		while [[ $C -lt $MAX ]]
		do	# Vars
			STATUS="${script_status[$C]}"	# Current status
			RET_FILE="$TEMP/$(basename ${script_name[$C]}).ret"
		
			# Do action according to current status
			case $STATUS in
			2)	# IS PID still available?
				pid=${script_pid[$C]} 
				if [[ ! -z "$(echo $pid)" ]]
				then	#if ! ls /proc/${script_pid[$C]}
					if ! ps $pid > /dev/zero
					#if kill -0 $pid  2>&/dev/null
					then	# Its finished
						read RET < "$RET_FILE"
						[[ -z "$RET" ]] && RET=1
						script_status[$C]=$RET
						((RUN--))
					fi
				else 	tui-status 1 "This should not happen, empty pid while running"
				fi
				;;
			3)	# Its TODO, can we start it?
				if [[ $RUN -lt $LIMIT ]] || [[ $LIMIT -eq 0 ]]
				then 	script_status[$C]=2
					STATUS=2
					((RUN++))
					script="${script_name[$C]}"
					[[ [./] = "${script:0:1}" ]] && PRE="" || PRE="./"
					cmd="\"${PRE}$script\" ; echo \$? > \"$RET_FILE\""
					touch "$RET_FILE"
					( eval "$cmd" ) &
					script_pid[$C]=$!
				fi
				;;
			*)	((DONE++))
				[[ $STATUS -eq 0 ]] && ((GOOD++))
				;;
			esac

			# Display latest status
			if ! $QUIET
			then	case $STATUS in
				0|1)	tui-status $STATUS "Finished ${script_name[$C]}"  ;;
				2)	tui-status $STATUS "Running ${script_name[$C]}" "${script_pid[$C]}" ;;
				3)	tui-status $STATUS "Waiting ${script_name[$C]}" ;;
				127)	tui-status 1 "Typo in script: \"${script_name[$C]}\""	;;
				*)	tui-status 1  "Invalid STATUS ($STATUS) on $C ${script_name[$C]}"	;;
				esac
			fi
			((C++))
		done
		
		if ! $QUIET
		then	tui-echo
			tui-title "Summary"
			tui-echo "Scripts completed:" "$DONE/$MAX"
			tui-echo "Currently running:" "$RUN/$LIMIT"
			tui-echo "Successfully executed:" "$GOOD"
			
			tui-echo
			tui-wait $WAIT "Wait for update..."
			echo
		else	sleep $WAIT
		fi
	done

EDIT:
I just think it looks cool, thank you guys!
[BASH] Script to manage background scripts (running, finished, exit code)-tui-bg-scripts-working2jpg
[BASH] Script to manage background scripts (running, finished, exit code)-tui-bg-scripts-progressjpg

Last edited by sea; 01-29-2015 at 02:41 PM..
This User Gave Thanks to sea For This Post:
Login or Register to Ask a Question

Previous Thread | Next Thread

9 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Terminal running bash/rsync script does not close with exit (MacOS High SIerra)

Hello, I am running a bash script to do an rsync back on a computer running MacOS High Sierra. This is the script I am using, #!/bin/bash # main backup location, trailing slash included backup_loc="/Volumes/Archive_Volume/00_macos_backup/" # generic backup function function backup {... (12 Replies)
Discussion started by: LMHmedchem
12 Replies

2. Shell Programming and Scripting

Problems running scripts in the background

Hi Could someone offer some help on this problem I've got with running a background process. As part of a script that does a stop/start/status for a piece of software called SAS, the following extract is from part of the start step. My issue is that when the script is run, the control... (0 Replies)
Discussion started by: GavP
0 Replies

3. Shell Programming and Scripting

Running scripts in background

Hi, below is my master script wihch inturn runs 2 scripts in background #master_script.sh ./subscript1.sh & ./subscript2.sh & executed the master_script.sh from unix command prompt $ ./master_script.sh it is executing the subscripts and they are completing fine, however master_script.sh is... (2 Replies)
Discussion started by: JSKOBS
2 Replies

4. Shell Programming and Scripting

Bash Question: HowTo Exit Script with User Input While Process is Running Mid-Loop?

Hi, I have written a script that allows me to repetitively play a music file $N times, which is specified through user input. However, if I want to exit the script before it has finished looping $N times, if I use CTRL+c, I have to CTRL+c however many times are left in order to complete the loop.... (9 Replies)
Discussion started by: hilltop_yodeler
9 Replies

5. Shell Programming and Scripting

Catch exit code of specific background process

Hi all, i hava a specific backgroud process. I have de PID of this process. At some time, the process finish his job, is there any way to catch the exit code? I use "echo $?" normally for commands. Thanks! (2 Replies)
Discussion started by: Xedrox
2 Replies

6. Shell Programming and Scripting

Capturing the exit status of the script running in background

Hi All, I have a scenario where I am executing some child shell scripts in background (using &)through a master parent script. Is there a way I can capture the exit status of each individual child script after the execution is completed. (2 Replies)
Discussion started by: paragkalra
2 Replies

7. Shell Programming and Scripting

Issues with exit after running jobs in background

I have the following sample script to run a script the jobs with the same priority(in this case field3) in parallel; wait for the jobs to finish and run the next set of jobs in parallel.When all the lines are read exit the script. I have the following script which is doing evrything I want... (1 Reply)
Discussion started by: hyennah
1 Replies

8. UNIX for Dummies Questions & Answers

background job finished notification

In my last job someone gave me the command to put in my .profile that let me know when a job I had running in the background finished. It was a word about 5 char long. I can't remember it! (4 Replies)
Discussion started by: nkeller
4 Replies

9. Shell Programming and Scripting

exit status of Invoking two or more scripts in background

I have a sript which is going to trigger other 3 scripts in background simultaneously for eg: Main Script:(main.sh) ----------- sh a.sh & sh b.sh & sh c.sh & How to catch the exit status and store it in a variable for all those three scripts in main script. Is there any other way of... (4 Replies)
Discussion started by: Omkumar
4 Replies
Login or Register to Ask a Question